<id>
Shoutbox Mod 231
</id>

<version>
RC5
</version>

<mod info>
This is an early beta of the shoutbox mod. It allows a "shoutbox" to be placed anywhere on your website. This allows members to chat quickly, rather than making posts.

This is NOT designed to be a chat-system, but is somewhere inbetween posting, and realtime chat.

Upload all files to the relevant directories, and chmod according to the other files in the same directory. Make sure shoutsettings.txt and shouts.txt are chmod'd to AT LEASE 666. ShoutDisplay.pl should be chmod 755, or the same as YaBB.pl
</mod info>

<author>
Andrew Aitken (LoonyPandora) and others
</author>

<homepage>
http://www.boardmod.com
</homepage>

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
);

1;
</search for>

<add before>
'shoutadmin',"ShoutAdmin.pl&ShoutAdmin",
'removeshouts',"ShoutAdmin.pl&RemoveShouts",
'shoutsettings2',"ShoutAdmin.pl&ShoutSettings2",
</add before>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'vote',"Poll.pl&DoVote",
</search for>

<add after>
'write_shouts',"Shoutbox.pl&WriteShouts",
'shout_smilies',"Shoutbox.pl&ShoutSmileys",
'useremoveshouts',"Shoutbox.pl&UserRemoveShouts",
</add after>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
 	$lp_shout = "shoutadmin|Shoutbox Settings|Shoutbox Mod by Andrew Aitken (LoonyPandora) and many others|";
	push (@boardmod_mods, "$lp_shout");
</add before>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$lp_shout = "Shoutbox|Andrew Aitken (LoonyPandora) and many others|Updated for YaBB 2.3.1 in community work from Batchman, DOT-COM, Derek Barnstorm, Driven, Unilat and ThM. Gives users an interactive shoutbox, almost like a chat-room, or instant messaging client direct on your forum. Can be utilised via an iframe from any page on your website. Ideal for \"portals\".|RC5|15th Mar 2009";
	push (@installed_mods, "$lp_shout");
</add before>

<edit file>
Sources/System.pl
</edit file>

<search for>
	# using sequential tag writing as hashes do not sort the way we like them to
	my @tags = qw(password realname email regdate regreason webtitle weburl spamcount spamtime signature postcount position addgroups icq aim yim skype gender usertext userpic regtime location bday timeselect timeoffset timeformat hidemail msn gtalk template language lastonline lastpost lastim im_ignorelist im_popup im_imspop notify_me board_notifications thread_notifications cathide postlayout session sesquest sesanswer favorites dsttimeoffset pageindex lastips onlinealert pmactprev pmmessprev pmviewMess buddylist offlinestatus awaysubj awayreply awayreplysent stealth reversetopic);
</search for>

<add after>
	push(@tags,"lp_shoutcount","lp_lastshout","lp_shout_muted","lp_shout_mute_reason","lp_shout_refresh","lp_shout_timestamp","on_load_focus","reverse_post","lp_shout_smileys","lp_shout_bbcode");
</add after>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
&LoadLanguage('Profile');
</search for>

<add after>
&LoadLanguage('Shoutbox');
</add after>

<search for>
	if    (${$uid.$user}{'position'} eq 'Administrator') { $tt = $MemStatAdmin; }
</search for>

<add before>
	($shout_mute_days, undef) = split(/\|/, ${$uid.$user}{'lp_shout_muted'});
</add before>

<search for>
 </tr><tr class="windowbg">
    <td width="320" align="left"><b>$profile_amv_txt{'11'}: </b><br /><br /></td>
    <td align="left">$userlastim<br /><br /></td>
</search for>

<add after>
 </tr><tr class="windowbg">
    <td width="320" align="left"><b>$shout_txt{'1'}</b><br /><br /></td>
    <td align="left"><input type="text" name="lp_shout_muted" size="4" value="$shout_mute_days" /><br /><br /></td>
 </tr><tr class="windowbg">
    <td width="320" align="left"><b>$shout_txt{'2'}</b><br /><br /></td>
    <td align="left"><input type="text" name="lp_shout_mute_reason" size="25" value="${$uid.$user}{'lp_shout_mute_reason'}" /><br /><br /></td>
</add after>

<search for>
		${$uid.$user}{'position'}  = $member{'settings7'};
		${$uid.$user}{'regdate'}   = $member{'dr'};
</search for>

<add after>
		$mute_until = ($member{'lp_shout_muted'}*86400)+int(time);
		${$uid.$user}{'lp_shout_muted'} = "$member{'lp_shout_muted'}|$mute_until";
		${$uid.$user}{'lp_shout_mute_reason'}   = "$member{'lp_shout_mute_reason'}";
</add after>

<search for>
	$post_count = ${$uid.$user}{'postcount'};
	if (!$post_count) { $post_count = 0 }
</search for>

<add after>
	$shout_count = ${$uid.$user}{'lp_shoutcount'};
	if (!$shout_count) { $shout_count = 0 }
</add after>

<search for>
	$post_per_day = sprintf("%.2f", ($post_count / $tmpmember_for_days));
</search for>

<add after>
	$shout_per_day = sprintf("%.2f", (${$uid.$user}{'lp_shoutcount'} / $tmpmember_for_days));
</add after>

<search for>
			<div style="float: left; width: 70%; padding-top: 5px; padding-bottom: 5px;">
			<b>${$uid.$user}{'postcount'}<br />$post_per_day</b> $profile_txt{'893'}
			</div>
</search for>

<add after>
			<div style="float: left; width: 30%; padding-top: 5px;  padding-bottom: 5px;">
			<b>$shout_txt{'3'} </b>
			</div>
			<div style="float: left; width: 70%; padding-top: 5px;  padding-bottom: 5px;">
			<b>${$uid.$user}{'lp_shoutcount'}<br />$shout_per_day</b> $shout_txt{'4'}
			</div>
</add after>

<search for>
		<div style="float: left; width: 70%; padding-top: 5px; padding-bottom: 5px;">$userlastim</div>
</search for>

<add after>
		<div style="float: left; width: 30%; padding-top: 5px;  padding-bottom: 5px;">
		<b>$shout_txt{'5'} </b>
		</div>
		<div style="float: left; width: 70%; padding-top: 5px;  padding-bottom: 5px;">
		~;
		if (!${$uid.$user}{'lp_lastshout'}) { $userlastshout = "$maintxt{'470'}" }
		else { $userlastshout = &timeformat(${$uid.$user}{'lp_lastshout'}); }
		$showProfile .= qq~$userlastshout
 		</div>
</add after>

<search for>
	$showProfile .= qq~<tr class="windowbg">
          <td align="left"><b>$profile_txt{'817'}</b><br /><span class="small">$profile_txt{'815'}</span></td>
</search for>

<add before>
	if (${$uid.$user}{'lp_shout_timestamp'}) { $lp_time_checked = qq~ checked="checked"~; }
	if (${$uid.$user}{'lp_shout_smileys'}) { $lp_smiley_checked = qq~ checked="checked"~; }
	if (${$uid.$user}{'lp_shout_bbcode'}) { $lp_bbcode_checked = qq~ checked="checked"~; }
	if (${$uid.$user}{'on_load_focus'}) { $on_load_focus_checked = qq~ checked="checked"~; }
	if (${$uid.$user}{'reverse_post'}) { $reverse_post_checked = qq~ checked="checked"~; }
</add before>

<search for>
          <td height="50" valign="middle" align="center" colspan="2"><input type="submit" name="moda" value="$profile_txt{'88'}" class="button" /><br /><span class="small">$profile_txt{'sid_expires_1'} $sid_expires $profile_txt{'sid_expires_2'}</span></td>
        </tr>
</search for>

<add before>
		<td valign="middle" align="left" colspan="2"><b>$shout_txt{'56'}</b></td>

		<tr class="windowbg">
          <td width="320" align="left"><b>$shout_txt{'36'}</b></td>
          <td align="left"><input type="checkbox" name="lp_shout_timestamp" $lp_time_checked /></td>
        </tr>
		<tr class="windowbg">
          <td width="320" align="left"><b>$shout_txt{'37'}</b></td>
          <td align="left"><input type="checkbox" name="lp_shout_smileys" $lp_smiley_checked /></td>
        </tr>
		<tr class="windowbg">
          <td width="320" align="left"><b>$shout_txt{'38'}</b></td>
          <td align="left"><input type="checkbox" name="lp_shout_bbcode" $lp_bbcode_checked /></td>
        </tr>
		<tr class="windowbg">
          <td width="320" align="left"><b>$shout_txt{'49'}</b></td>
          <td align="left"><input type="checkbox" name="on_load_focus" $on_load_focus_checked /></td>
        </tr>
		<tr class="windowbg">
          <td width="320" align="left">$shout_txt{'40'}</td>
          <td align="left"><input type="checkbox" name="reverse_post" $reverse_post_checked /></td>
        </tr>
		<tr class="windowbg">
          <td width="320" align="left"><b>$shout_txt{'39'}</b></td>
          <td align="left"><input type="text" name="lp_shout_refresh" size="3" value="${$uid.$user}{'lp_shout_refresh'}" /></td>
        </tr>

        </tr><tr class="catbg">
</add before>

<search for>
		${$uid.$user}{'timeformat'} = $member{'timeformat'};
</search for>

<add after>
		${$uid.$user}{'lp_shout_refresh'}   = "$member{'lp_shout_refresh'}";
		${$uid.$user}{'lp_shout_timestamp'} = "$member{'lp_shout_timestamp'}";
		${$uid.$user}{'lp_shout_smileys'}   = "$member{'lp_shout_smileys'}";
		${$uid.$user}{'lp_shout_bbcode'}    = "$member{'lp_shout_bbcode'}";
		${$uid.$user}{'on_load_focus'}      = "$member{'on_load_focus'}";
		${$uid.$user}{'reverse_post'}       = "$member{'reverse_post'}";
</add after>

<edit file>
Languages/English/Error.lng
</edit file>

<search for>
## MemberGroups ##
'newpostdep_gmod'		=> 'Sorry, Global Mods can\'t modify Postdependent users because the Maintenance->"Rebuild Memberlist" must be run after and that function is only available in Maintenance Mode, so it would deny your login!',
</search for>

<add after>
## Shoutbox ##
'shout_delete'			=> 'You do not have permissions to delete this shout!',
</add after>

<edit file>
Sources/Register.pl
</edit file>

<search for>
	${$uid.$reguser}{'addgroups'} = $member{'joinmemgroup'};
</search for>

<add after>
	# Shoutbox defaults
	${$uid.$reguser}{'lp_shout_smileys'} = 1;
	${$uid.$reguser}{'lp_shout_timestamp'} = 1;
	${$uid.$reguser}{'lp_shout_bbcode'} = 1;
	${$uid.$reguser}{'on_load_focus'} = 1;
	${$uid.$reguser}{'reverse_post'} = 1;
	${$uid.$reguser}{'lp_shout_refresh'} = 45;
</add after>